// Andrei Grigorean
#include <cassert>

#include <fstream>
using namespace std;

ifstream fin("color.in");
ofstream fout("color.out");

const int MAX_N = 100;

int main() {
    int n;
    fin >> n;
    assert(3 <= n && n <= MAX_N);

    if (n == 3) {
        fout << "1\n";
        for (int i = 0; i < n; ++i)
            fout << i << " " << n << " 1\n";
        for (int i = 0; i < n; ++i)
            fout << i << " " << ((i + 1) % n) << " 1\n";
        return 0;
    }

    if (n <= 6) {
        fout << "2\n";
        for (int i = 0; i < n; ++i)
            fout << i << " " << n << " " << ((i % 2) + 1) << "\n";
        for (int i = 0; i < n; ++i)
            fout << i << " " << ((i + 1) % n) << " " << ((i % 2) + 1) << "\n";
        return 0;
    }

    fout << "3\n";
    for (int i = 0; i < n; ++i)
        fout << i << " " << n << " " << ((i % 2) + 1) << "\n";
    for (int i = 0; i < n; ++i)
        fout << i << " " << ((i + 1) % n) << " 3\n";
    return 0;
}
