//Adi Budau

#include <iostream>
#include <fstream>

using namespace std;

inline int groups(int N, int colors) {
    int answer = N / (colors + 1);
    if (N % (colors + 1))
        ++answer;
    return answer;
}

int main() {
    ifstream cin("color.in");
    ofstream cout("color.out");

    int N; cin >> N;
    if (N == 3) {
        cout << "1\n";
        cout << "0 1 1\n1 2 1\n2 0 1\n";
        cout << "0 3 1\n1 3 1\n2 3 1\n";
        return 0;
    }
    int colors;
    for (colors = 1; groups(N, colors) > colors; ++colors);

    cout << colors << "\n";
    for (int i = 0, j = 0, group = 1; i < N; i = j, ++group) {
        for (j = i; j < i + colors + 1 && j < N; ++j) {
            cout << j << " " << (j + 1) % N << " " << (j - i) % colors + 1 << "\n";
            cout << j << " " << N << " " << group << "\n";
        }
    }
}
