#include <cstdio>
#include <algorithm>
#include <fstream>
#include <iostream>
#include <vector>
#include <queue>
#include <map>
#include <cstring>
#include <string>
#include <set>

#define pb push_back
#define mp make_pair
#define f first
#define s second
#define ll long long

const int MAXN = 100005;
const int mod = 1114111;

using namespace std;

int N, X[MAXN], ans[MAXN];

int main() {

	ifstream cin("echival2.in");
	ofstream cout("echival2.out");
	
	cin >> N;

	X[1] = 1;
	X[2] = 2;
	X[3] = 5;
	X[4] = 7;
	X[5] = 12;
	
	int current = 5;
	
	for (int i = 1; X[current] <= N; ++i) {
		++current ;

		X[current] = 3 + 2 * X[current - 2] - X[current - 4];
		
		if (X[current] >= mod)
			X[current] %= mod;
	}

/*	
	for (int i = 1; X[i] <= N; ++i) {
		cerr << X[i] << " " ;
	}

	cerr << "\n";
*/	ans[0] = 1;

	for (int i = 1; i <= N; ++i) {		
		int sgn = 1, p = 0;

		for (int j = 1 ; X[j] <= i; ++j) {
			if (p == 2) {
				sgn = sgn * (-1);
				p = 0;
			}

			ans[i] += sgn * ans[i - X[j]];
			
			if (ans[i] >= mod)
				ans[i] -= mod;
			++p;
		}
		while(ans[i] <= 0)
			ans[i] += mod;

	}
/*	
	for (int i = 1; i <= N; ++i)
		cerr << ans[i] << " " ;
*/	
	int m = ans[N] - ans[N - 1];
	
	while(m <= 0)
		m += mod;

	cout << m << "\n";

	return 0;
}
