//Dragos Oprica
//Dinamica in N^2 cu memoizare

#include <tr1/unordered_map>
#include <iostream>
#include <fstream>
using namespace std;
using namespace tr1;

const int MOD=1114111;

ifstream fin ("echival2.in");
ofstream fout ("echival2.out");

struct hashpair {
	std::tr1::hash <int> hf; 

	size_t operator () (const pair<int,int> &ob) const {
		return hf (ob.first) * 9123191 + hf (ob.second);
	}
}; 

unordered_map <pair <int,int>,int, hashpair> dp; 
int NR;

int compute (int N,int K) {
	if (dp[make_pair (N,K)])
		return dp[make_pair (N,K)];
	
	if (N<K)
		return 0;

	if (N==K) {
		dp[make_pair (N,K)]=1;
        return 1;
	}

	int ret; compute (N,K+1); compute (N-K,K);
	dp[make_pair (N,K)]=ret=(dp[make_pair (N,K+1)]+dp[make_pair (N-K,K)])%MOD; 
    return ret;
}

int main () {
	cin>>NR;
    cout<<compute (NR,2);

	return 0;
}
