//Dragos Oprica

#include <iostream>
#include <fstream>
using namespace std;

ifstream fin ("mstack.in");
ofstream fout ("mstack.out");

const int MAXSTACKS=13;

struct mstack {
    int stack[MAXSTACKS];

    mstack () {
		stack[1]=stack[2]=stack[3]=0;
	}

    void move_elements (int from,int to) {
		int to_move=(stack[from]+1)/2;
        int to_none=stack[from]-to_move;

		stack[from]-=to_move;
		stack[to]+=to_move;

		for (int i=1; i<=to_none; ++i)
			fout<<"move "<<from<<" 1\n";
		for (int i=1; i<=to_move; ++i)
			fout<<"move "<<from<<" "<<to<<"\n";
		for (int i=1; i<=to_none; ++i)
			fout<<"move 1 "<<from<<"\n";
	}

	void push () {
		stack[3]++; fout<<"push 3\n";

		if (stack[1]+1<stack[2]+stack[3]) {
			if (!stack[2])
				move_elements (3,2);

			stack[2]--; stack[1]++;
			fout<<"move 2 1\n";
		}
	}

	void top () {
		if (!stack[3])
			move_elements (2,3);

		fout<<"top 3\n";
	}

	void middle () {
		if (!stack[2])
			move_elements (3,2);

		fout<<"top 2\n";
	}

	void pop () {
        if (!stack[3])
			move_elements (2,3);

		stack[3]--; fout<<"pop 3\n";
		if (stack[1]>stack[2]+stack[3]) {
			stack[1]--; stack[2]++;
			fout<<"move 1 2\n";
		}
	}
};

int main () {
	int N; fin>>N;


	mstack myStack;
	for (int i=1; i<=N; ++i) {
		string op; fin>>op;

		if (op=="push")
			myStack.push ();
		else if (op=="pop")
			myStack.pop ();
		else if (op=="top")
			myStack.top ();
		else
			myStack.middle ();
	}

	return 0;
}

