//Dragos Oprica
#include <iostream>
#include <fstream>
#include <set>
using namespace std;

const int NMAX=100005;

ifstream fin ("echival1.in");
ofstream fout ("echival1.out");
                     
pair <int,int> poz[2][NMAX];
int V[2][NMAX],viz[NMAX];         
multiset <int> mySet; 
int N;      

multiset <int> create_cycles () {
	multiset <int> ret;

	for (int i=1; i<=N; ++i)
		viz[i]=0;
	for (int i=1; i<=N; ++i)
		if (!viz[i]) {
			pair <int,int> myPoz=poz[1][i];
			int cycle=0,value=i;
			
			while (!viz[value]) {
				++cycle; viz[value]=1;

				if (myPoz.first==0) {
					value=V[1][myPoz.second];
					if (poz[1][value]==make_pair (1,myPoz.second))
						myPoz=poz[0][value];
					else
						myPoz=poz[1][value]; 
				}
				else {
					value=V[0][myPoz.second]; 
					if (poz[1][value]==make_pair (0,myPoz.second))
						myPoz=poz[0][value];
					else
						myPoz=poz[1][value]; 
				}		
			}
			
            ret.insert (cycle);
		}

	return ret;
}

int main () {
	fin>>N;
	for (int i=0; i<2; ++i)
		for (int j=1; j<=N; ++j) {
	    	fin>>V[i][j];
			if (poz[0][V[i][j]]!=make_pair (0,0))
				poz[1][V[i][j]]=make_pair (i,j);
			else
				poz[0][V[i][j]]=make_pair (i,j);
		}    
	mySet=create_cycles ();
	for (int t=1; t<=10; ++t) {
		for (int i=0; i<2; ++i)
			for (int j=1; j<=N; ++j)
				poz[i][j]=make_pair (0,0);

		for (int i=0; i<2; ++i)
			for (int j=1; j<=N; ++j) {
				fin>>V[i][j];
				if (poz[0][V[i][j]]!=make_pair (0,0))
					poz[1][V[i][j]]=make_pair (i,j);
				else
					poz[0][V[i][j]]=make_pair (i,j);
			}
		if (mySet==create_cycles ())
			fout<<"1\n";
		else
			fout<<"0\n";
	}
	return 0;
}
